﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows;
using Infragistics.Controls.Charts;
using System.Collections;

namespace XamDataChartLegendItemsOrder
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            this.xamDataChart1.WindowRect = new Rect(0, 0, 1, 1);
        }

        List<ContentControl> temp = new List<ContentControl>();

        private void xamDataChart1_Loaded(object sender, RoutedEventArgs e)
        {
            ContentPresenter cp = Utilities.GetDescendantFromName(xmLegend, "ContentPresenter") as ContentPresenter;
            if (cp != null)
            {
                StackPanel sp = cp.Content as StackPanel;

                if (sp != null)
                {
                    Dispatcher.BeginInvoke(new Action(() =>
                    {
                        int count = sp.Children.Count;
                        for (int i = count - 1; i >= 0; i--)
                        {
                            ContentControl cc = sp.Children[i] as ContentControl;
                            sp.Children.Remove(sp.Children[i] as ContentControl);
                            if (cc != null) temp.Add(cc);
                        }

                        for (int i = count - 1; i >= 0; i--)
                        {
                            ContentControl cc = temp[0] as ContentControl;
                            temp.Remove(temp[0] as ContentControl);
                            if (cc != null) sp.Children.Add(cc);
                        }
                    }), System.Windows.Threading.DispatcherPriority.Background, null);
                }
            }
        }
    }

    public class DataCollection : ObservableCollection<DataPoint>
    {
        //private static readonly Random DataGenerator = new Random();
        public DataCollection()
        {
            foreach (var item in RandomHelper.Generate())
            {
                this.Items.Add(item);
            }
        }
    }

    public class DataPoint
    {
        public string Label { get; set; }
        public double Value { get; set; }
        public double Value1 { get; set; }
        public double Value2 { get; set; }
        public double Value3 { get; set; }
        public double Value4 { get; set; }
        public int Index { get; set; }
        private DateTime _Date;
        public DateTime Date
        {
            get
            { return _Date; }
            set
            { _Date = value; }
        }
        public DateTime OnlyDate
        {
            get { return _Date.Date; }
        }
    }

    public static class RandomHelper
    {
        private static readonly Random DataGenerator = new Random();
        public static List<DataPoint> Generate()
        {
            List<DataPoint> DataPoints = new List<DataPoint>();
            DataPoints.Clear();
            double curr = 250;
            double curr1 = 350;
            double curr2 = 200;
            double curr3 = 300;
            double curr4 = 200;
            DateTime date = new DateTime(2009, 1, 1, 12, 00, 00);
            for (int i = 0; i < 20000; i++)
            {
                //curr
                if (DataGenerator.NextDouble() > .5)
                {
                    curr += DataGenerator.NextDouble();
                }
                else
                {
                    curr -= DataGenerator.NextDouble();
                }

                //curr1
                if (DataGenerator.NextDouble() > .5)
                {
                    curr1 += DataGenerator.NextDouble();
                }
                else
                {
                    curr1 -= DataGenerator.NextDouble();
                }

                //curr2
                if (DataGenerator.NextDouble() > .5)
                {
                    curr2 += DataGenerator.NextDouble();
                }
                else
                {
                    curr2 -= DataGenerator.NextDouble();
                }

                //curr3
                if (DataGenerator.NextDouble() > .5)
                {
                    curr3 += DataGenerator.NextDouble();
                }
                else
                {
                    curr3 -= DataGenerator.NextDouble();
                }

                //curr4
                if (DataGenerator.NextDouble() > .5)
                {
                    curr4 += DataGenerator.NextDouble();
                }
                else
                {
                    curr4 -= DataGenerator.NextDouble();
                }

                DataPoints.Add(
                    new DataPoint
                    {
                        Date = date,
                        Index = i,
                        Label = i.ToString(),
                        Value = curr,
                        Value1 = curr1,
                        Value2 = curr2,
                        Value3 = curr3,
                        Value4 = curr4
                    });
                date = date.AddMinutes(30);
            }
            return DataPoints;
        }
    }

}

